﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.8
@EndOfDesignText@
' actPersons - ACTIVITY
' Author: 

#Region VERSIONS 
' V. 1.0	00/00/2020
#End Region

#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Private mmapPersons As Map ' map of tPerson type.
	Private mXCLV_Width As Int
	Private mPersonItemHeight As Int
End Sub

Sub Globals
	Private xclvPersons As CustomListView

#Region PERSON LAYOUT 
	Private lblID As Label
	Private lblFirstName As Label
	Private lblLastName As Label
	Private lblAddress As Label
	Private lblProfessionID As Label
#End Region

End Sub

#Region ACTITITY'S EVENTS 

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("layPersons")
	mmapPersons.Initialize

	Dim v As B4XView = xclvPersons.GetBase
	mXCLV_Width = v.Width
	mPersonItemHeight = 124dip
End Sub

Sub Activity_Resume
	FillXCLV
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

#End Region

#Region VIEWS' EVENTS 

Sub xclvPersons_ItemClick (Index As Int, Value As Object)
	Dim Person As tPerson = Value
	LogPerson(Person)
End Sub

Sub xclvPersons_ItemLongClick (Index As Int, Value As Object)
	
End Sub

#End Region

#Region METHODS 

Private Sub FillXCLV
	mmapPersons = modDB.GetAllPersons
	xclvPersons.Clear
	For Each Person In mmapPersons.Values
		xclvPersons.Add(CreatePersonItem(Person, mXCLV_Width, mPersonItemHeight), Person)
	Next
End Sub

Private Sub CreatePersonItem(Person As tPerson, Width As Int, Height As Int) As Panel
	Dim pnl As Panel
	pnl.Initialize("")
	pnl.SetLayout(0, 0, Width, Height)
	pnl.LoadLayout("layPersonItem")
	lblID.Text = Person.ID
	lblFirstName.Text = Person.FirstName
	lblLastName.Text = Person.LastName
	lblAddress.Text = Person.Address
	lblProfessionID.Text = Person.ID
	Return pnl
End Sub

Private Sub LogPerson(Person As tPerson)
	Log("________________________")
	Log("ID: " & Person.ID)
	Log("FirstName: " & Person.FirstName)
	Log("LastName: " & Person.LastName)
	Log("Address: " & Person.Address)
	Log("ProfessionID: " & Person.ProfessionID)
	
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(Person.ID & CRLF)
	sb.Append(Person.FirstName & CRLF)
	sb.Append(Person.LastName & CRLF)
	sb.Append(Person.Address & CRLF)
	sb.Append("Prof. ID: " & Person.ProfessionID)
	ToastMessageShow(sb.ToString, True)
End Sub

#End Region

#Region ACTIVITY'S UTILITIES 

#End Region
